/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/
#include "ch32v10x.h"
#include <rtthread.h>
#include <rthw.h>
#include "drivers/pin.h"

/* Global typedef */

/* Global define */

/* LED0ͨrtpinӿ  */

#define PWM_DUTY_MAX 10000

#define GPIOA1  15   //PA1
#define GPIOA2  16
#define adcA4   18
#define pwmA6   0x0200


/* Global Variable */
rt_sem_t sem1;
rt_sem_t sem2;

int RxBuffer2;
int RxCnt2;


void th1_entry1()
{
    ADC_RegularChannelConfig(ADC1, 4, 1, 0);
    ADC1->CTLR2 |= ((uint32_t)0x00500000);
    while((ADC1->STATR & ADC_FLAG_EOC) == (uint8_t)RESET)
    {}


    if ((ADC1->RDATAR) > 3800 )
    {
        timer_pwm_duty(635);
    }
    else if ((ADC1->RDATAR) < 3800)
    {
        timer_pwm_duty(865);
    }
}
void th1_entry2()
{
    if (RxBuffer2 == '1')
    {
        timer_pwm_duty(635);
    }
    else if (RxBuffer2 == '2')
    {
        timer_pwm_duty(865);
    }
}

/* LED1ֱͨӵõײ */
void port_io_ad_pwm_init(void)
{
    unsigned int freq, period_temp, match_temp, duty, freq_div;
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    TIM_OCInitTypeDef  TIM_OCInitStructure;

    rt_pin_mode(GPIOA1, PIN_MODE_OUTPUT);
    rt_pin_mode(GPIOA2, PIN_MODE_OUTPUT);


    rt_pin_mode(adcA4, PIN_MODE_INPUT_AIN);
    if(SystemCoreClock > 84000000)  RCC_ADCCLKConfig(RCC_PCLK2_Div8);           //ADCƵӣADCʲܳ14M
    else RCC_ADCCLKConfig(RCC_PCLK2_Div6);
    ADC_InitTypeDef* ADC_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_ADC1 , ENABLE );   //ʹADC1ͨʱ
    ADC_InitStructure->ADC_Mode = ADC_Mode_Independent;                  //ADCģʽ:ADC1ڶģʽ
    ADC_InitStructure->ADC_ScanConvMode = DISABLE;                       //ģתڵͨģʽ
    ADC_InitStructure->ADC_ContinuousConvMode = DISABLE;                 //ģתڵתģʽ
    ADC_InitStructure->ADC_ExternalTrigConv = ADC_ExternalTrigConv_None; //תⲿ
    ADC_InitStructure->ADC_DataAlign = ADC_DataAlign_Right;              //ADCҶ
    ADC_InitStructure->ADC_NbrOfChannel = 1;                             //˳йתADCͨĿ
    ADC_Init(ADC1, &ADC_InitStructure);                                 //ADC_InitStructָĲʼADCxļĴ

    rt_pin_mode(pwmA6, PIN_MODE_OUTPUT_OD);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
    GPIO_PinRemapConfig(GPIO_FullRemap_TIM3, ENABLE);
    freq_div = (unsigned int)((SystemCoreClock / freq) >> 16);                            //ٷƵ
    period_temp = (unsigned int)(SystemCoreClock/(freq*(freq_div + 1)));                  //
    match_temp = period_temp * duty / PWM_DUTY_MAX;

    //ʼTIM1-4
    TIM_TimeBaseStructure.TIM_Period = period_temp - 1;                     //һ¼װԶװؼĴڵֵ
    TIM_TimeBaseStructure.TIM_Prescaler = freq_div;                         //ΪTIMxʱƵʳԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;                 //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;             //TIMϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;

    //ʼTIM1-4 PWMģʽ
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;                       //ѡʱģʽ:TIMȵģʽ2
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;           //Ƚʹ
    TIM_OCInitStructure.TIM_OutputNState = TIM_OutputState_Disable;
    TIM_OCInitStructure.TIM_Pulse = match_temp;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;                //:TIMȽϼԸ
    TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCPolarity_Low;               //:TIMȽϼԸ
    TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset;
    TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;

    TIM_TimeBaseInit((TIM_TypeDef *) TIM3_BASE, &TIM_TimeBaseStructure);
    TIM_OC1Init((TIM_TypeDef *) TIM3_BASE, &TIM_OCInitStructure );                       //ʱͨ1ʼ
    TIM_OC1PreloadConfig((TIM_TypeDef *) TIM3_BASE, TIM_OCPreload_Enable);               //ʱԤװ
    TIM_OC1FastConfig((TIM_TypeDef *) TIM3_BASE, TIM_OC1FE);

    TIM_Cmd((TIM_TypeDef *) TIM3_BASE, ENABLE);                                              //ʱʹ
    TIM_CtrlPWMOutputs((TIM_TypeDef *) TIM3_BASE, ENABLE );


}

void USARTx_CFG(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;
    NVIC_InitTypeDef  NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2|RCC_APB1Periph_USART3, ENABLE);

    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(USART2, &USART_InitStructure);
    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);

    USART_Init(USART3, &USART_InitStructure);
    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);

    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    USART_Cmd(USART2, ENABLE);
    USART_Cmd(USART3, ENABLE);
}

void timer_pwm_duty(unsigned int duty)
{
    unsigned int match_temp;
    unsigned int period_temp;

    period_temp = ((TIM_TypeDef *) TIM3_BASE)->ATRLR;    //ȡʱֵ
    match_temp = period_temp * duty / PWM_DUTY_MAX;             //ռձ


   (*(volatile unsigned int *)(0x40000434 + (pwmA6&0x03) * 0x04)) = match_temp;

}


/* mainֻһ֮߳һ֮⻹tshell,idle
   *    mainֻһLED˸main̵߳עrtthread_startup
   *   
 * */
int main(void)
{
    USARTx_CFG();
    port_io_ad_pwm_init();

    rt_pin_mode(GPIOA2, PIN_MODE_OUTPUT);

	rt_thread_create("th1", th1_entry1, NULL, 512, 20, 5);
	rt_thread_create("th2", th1_entry2, NULL, 512, 20, 5);






	while(1)
	{
	    rt_pin_write(GPIOA2, 0);
	    rt_thread_mdelay(500);
	    rt_pin_write(GPIOA2, 1);
	    rt_thread_mdelay(500);

	}
}


/* ʹӿڲI/O */
int led(void)
{
    rt_uint8_t count;

//    rt_pin_mode(LED0_PIN, PIN_MODE_OUTPUT);
//
//    for(count = 0 ; count < 10 ;count++)
//    {
//        rt_pin_write(LED0_PIN, PIN_LOW);
//        rt_kprintf("led on, count : %d\r\n", count);
//        rt_thread_mdelay(500);
//
//        rt_pin_write(LED0_PIN, PIN_HIGH);
//        rt_kprintf("led off\r\n");
//        rt_thread_mdelay(500);
//    }
    return 0;
}

void USART3_IRQHandler(void)
{
  if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET)
  {

    RxBuffer2 = USART_ReceiveData(USART3);




    USART_ITConfig(USART3, USART_IT_RXNE, DISABLE);
  }
}




MSH_CMD_EXPORT(led, RT-Thread first led sample by using I/O driver);



